unit unit_calc_base_class_func;

// {$mode objfpc}{$H+}

interface

uses
  Dialogs, Classes, SysUtils, StdCtrls;

type

	tcalc_func_name = (  name_add, name_sub, name_mult, name_div, name_power,
								name_sincos, name_cos, name_sin, name_tan,
								name_arccos, name_arcsin, name_arctan,
								name_cosh, name_sinh, name_tanh,
								name_arccosh, name_arcsinh, name_arctanh,
								name_cycletorad, name_degtograd, name_degtorad, name_gradtodeg,
								name_gradtorad, name_radtocycle, name_radtodeg, name_radtograd );
	tcalc_funcs = class(tbutton)

		private

		public
        	format: TFloatFormat;
  			Precision: Integer;
			Digits: Integer;

//			desc_memo : tmemo;
			output_memo : tmemo;
			input_edit : tedit;

			str_describe : string;

			constructor create(	in_input_edit : tedit;
										in_output_memo : tmemo );
			destructor destroy;

			procedure button_enter; virtual;
			procedure button_reset; virtual;
			function get_descr : string; virtual;
         procedure button_select; virtual;

         function get_value( in_data : extended) : string;
	end;


implementation


	constructor tcalc_funcs.create( in_input_edit : tedit;
												in_output_memo : tmemo );
	begin
		self.str_describe:='математическая функция tcalc_funcs.create';

		self.output_memo:=in_output_memo;
		self.input_edit:=in_input_edit;

      format:=ffExponent;
      Precision:=0;
      Digits:=0;
	end;

	destructor tcalc_funcs.destroy;
	begin
	end;

	procedure tcalc_funcs.button_enter;
	begin
   	self.output_memo.Lines.Add('tcalc_funcs: button_enter1');
  		showmessage('tcalc_funcs: button_enter1');
	end;

	procedure tcalc_funcs.button_reset;
	begin
   	self.output_memo.Lines.Add('tcalc_funcs: button_reset1');
  		showmessage('tcalc_funcs: button_reset1');
	end;

	function tcalc_funcs.get_descr : string;
	begin
		self.str_describe:='математическая функция tcalc_funcs.descr';
      get_descr:=self.str_describe;
	end;

   procedure tcalc_funcs.button_select;
	begin
		self.output_memo.Lines.Add(self.str_describe);
      self.output_memo.Lines.Add('tcalc_funcs.button_select: Введите первый аргумент:');
	end;

   function tcalc_funcs.get_value( in_data : extended) : string;
   begin
   	try
      	get_value:=FloatToStrF(in_data, format, Precision, Digits);
//      output:=format('%e',[input]);
    	except
	      get_value:='ошибка: число не конвертируется в текст';
    	end;

   end;

end.

