unit unit_calc_sincos;

// {$mode objfpc}{$H+}

interface

uses
  Dialogs, Classes, SysUtils, math, unit_calc_base_class_func, unit_conv_data;

type

	tcalc_sincos = class(tcalc_funcs)
		public
      arg, result_sin, result_cos : extended;
		procedure button_enter; override;
		procedure button_reset; override;
		function get_descr : string; override;
      procedure button_select; override;
	end;


implementation


	procedure tcalc_sincos.button_enter;
	begin
		try
			self.arg:=StrToFloat(self.input_edit.Text);
      except
			self.output_memo.Lines.Add('введён не верный аргумент');
         exit;
      end;
      self.output_memo.Lines.Add('ведён аргумент '+self.get_value(self.arg));
      sincos(self.arg, self.result_sin, self.result_cos);
      self.output_memo.Lines.Add('результат sin='+self.get_value(self.result_sin)
											+' cos='+self.get_value(self.result_cos));

end;

	procedure tcalc_sincos.button_reset;
	begin
   	self.output_memo.Clear;
      self.input_edit.Clear;
	end;

	function tcalc_sincos.get_descr : string;
	begin
		self.str_describe:='Математическая функция sin и cos';
      get_descr:=self.str_describe;
	end;

	procedure tcalc_sincos.button_select;
	begin
		self.output_memo.Lines.Add(self.str_describe);
      self.output_memo.Lines.Add('Введите аргумент:');
	end;


end.

