unit unit_main;

// {$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  Arrow, EditBtn, FileCtrl, ExtCtrls, ComCtrls, ShellCtrls, PairSplitter,
  StdCtrls, Grids, Spin,
  unit_calc_base_class_func,
  unit_calc_add, unit_calc_sub, unit_calc_mult, unit_calc_div,
  unit_calc_power,
	unit_calc_sincos, unit_cos, unit_sin, unit_tan,
		unit_arccos, unit_arcsin, unit_arctan,
		unit_cosh, unit_sinh, unit_tanh,
		unit_arccosh, unit_arcsinh, unit_arctanh,
		unit_cycletorad, unit_radtocycle, unit_radtograd, unit_gradtorad,
		unit_degtorad, unit_radtodeg, unit_degtograd, unit_gradtodeg  ;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button_const_pi: TButton;
   Button_cycletorad: TButton;
   Button_degtorad: TButton;
   Button_radtograd: TButton;
   Button_degtograd: TButton;
   Button_radtocycle: TButton;
   Button_radtodeg: TButton;
   Button_gradtorad: TButton;
   Button_gradtodeg: TButton;
   Button_cosh: TButton;
   Button_sinh: TButton;
   Button_tanh: TButton;
   Button_arccosh: TButton;
   Button_arcsinh: TButton;
   Button_arctanh: TButton;
   Button_arctan: TButton;
   Button_arcsin: TButton;
   Button_arccos: TButton;
   Button_tan: TButton;
   Button_sin: TButton;
   Button_cos: TButton;
   Button_sincos: TButton;
    Button_power: TButton;
    Button_div: TButton;
    Button_mult: TButton;
    Button_sub: TButton;
    Button_add: TButton;
   Button_log_reset: TButton;
   ComboBox_log_val_format: TComboBox;

   Edit_input_data: TEdit;
   GroupBox_Digits: TGroupBox;
   GroupBox_Precision: TGroupBox;
   GroupBox_log_val_format: TGroupBox;

   Memo_log: TMemo;
   PageControl1: TPageControl;
   PageControl2: TPageControl;
   ScrollBox_func_arif: TScrollBox;
   SpinEdit_Precision: TSpinEdit;
   SpinEdit_Digits: TSpinEdit;
   StatusBar_calc: TStatusBar;


	calc_add : tcalc_add;
	calc_sub : tcalc_sub;
	calc_mult : tcalc_mult;

	calc_div : tcalc_div;
	calc_power : tcalc_power;
	calc_sincos : tcalc_sincos;

	calc_cos : tcalc_cos;
	calc_sin : tcalc_sin;
	calc_tan : tcalc_tan;

	calc_arccos : tcalc_arccos;
	calc_arcsin : tcalc_arcsin;
	calc_arctan : tcalc_arctan;

	calc_cosh : tcalc_cosh;
	calc_sinh : tcalc_sinh;
	calc_tanh : tcalc_tanh;

	calc_arccosh : tcalc_arccosh;
	calc_arcsinh : tcalc_arcsinh;
	calc_arctanh : tcalc_arctanh;


	calc_cycletorad : tcalc_cycletorad;
	calc_radtocycle : tcalc_radtocycle;
	calc_radtograd : tcalc_radtograd;
	calc_gradtorad : tcalc_gradtorad;

	calc_degtorad : tcalc_degtorad;
	calc_radtodeg : tcalc_radtodeg;
	calc_degtograd : tcalc_degtograd;
	calc_gradtodeg : tcalc_gradtodeg;
TabSheet_cons: TTabSheet;





TabSheet_convert_data: TTabSheet;


TabSheet_log_val_format: TTabSheet;
TabSheet_log: TTabSheet;

TabSheet_func_arif: TTabSheet;
TabSheet_func_trinogom: TTabSheet;

   procedure Button_arccosClick(Sender: TObject);
   procedure Button_arccoshClick(Sender: TObject);
   procedure Button_arcsinClick(Sender: TObject);
   procedure Button_arcsinhClick(Sender: TObject);
   procedure Button_arctanClick(Sender: TObject);
   procedure Button_arctanhClick(Sender: TObject);
   procedure Button_const_piClick(Sender: TObject);
   procedure Button_cosClick(Sender: TObject);
   procedure Button_coshClick(Sender: TObject);
   procedure Button_cycletoradClick(Sender: TObject);
   procedure Button_degtogradClick(Sender: TObject);
   procedure Button_degtoradClick(Sender: TObject);
   procedure Button_divClick(Sender: TObject);
   procedure Button_gradtodegClick(Sender: TObject);
   procedure Button_gradtoradClick(Sender: TObject);
   procedure Button_log_resetClick(Sender: TObject);
   procedure Button_multClick(Sender: TObject);
   procedure Button_powerClick(Sender: TObject);
   procedure Button_radtocycleClick(Sender: TObject);
   procedure Button_radtodegClick(Sender: TObject);
   procedure Button_radtogradClick(Sender: TObject);
   procedure Button_sinClick(Sender: TObject);
   procedure Button_sincosClick(Sender: TObject);
   procedure Button_sinhClick(Sender: TObject);
   procedure Button_subClick(Sender: TObject);
   procedure Button_addClick(Sender: TObject);
   procedure Button_tanClick(Sender: TObject);
   procedure Button_tanhClick(Sender: TObject);

   procedure ComboBox_log_val_formatChange(Sender: TObject);
   procedure Edit_input_dataKeyDown(Sender: TObject; var Key: Word;
     Shift: TShiftState);


   procedure FormCreate(Sender: TObject);
   procedure SpinEdit_DigitsChange(Sender: TObject);
   procedure SpinEdit_PrecisionChange(Sender: TObject);

  private
    { private declarations }

  public
    { public declarations }

	obj_func_calc : tcalc_funcs;

	function set_calc_func(calc_func_name : tcalc_func_name ) : integer;

  end;

var
  Form1: TForm1;

implementation

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
	self.Memo_log.Clear;
	self.Edit_input_data.Clear;

	self.calc_add:=tcalc_add.create( self.Edit_input_data,
												self.Memo_log);
   self.Button_add.Hint:=self.calc_add.get_descr;


	self.calc_sub:=tcalc_sub.create( self.Edit_input_data,
												self.Memo_log);
   self.Button_sub.Hint:=self.calc_sub.get_descr;


	self.calc_mult:=tcalc_mult.create(self.Edit_input_data,
													self.Memo_log);
   self.Button_mult.Hint:=self.calc_mult.get_descr;


	self.calc_div:=tcalc_div.create(self.Edit_input_data,
												self.Memo_log);
   self.Button_div.Hint:=self.calc_div.get_descr;


	self.calc_power:=tcalc_power.create(self.Edit_input_data,
													self.Memo_log);
   self.Button_power.Hint:=self.calc_power.get_descr;


	self.calc_sincos:=tcalc_sincos.create(self.Edit_input_data,
														self.Memo_log);
   self.Button_sincos.Hint:=self.calc_sincos.get_descr;


	self.calc_cos:=tcalc_cos.create(self.Edit_input_data,
														self.Memo_log);
   self.Button_cos.Hint:=self.calc_cos.get_descr;

	self.calc_sin:=tcalc_sin.create(self.Edit_input_data,
														self.Memo_log);
   self.Button_sin.Hint:=self.calc_sin.get_descr;

	self.calc_tan:=tcalc_tan.create(self.Edit_input_data,
														self.Memo_log);
   self.Button_tan.Hint:=self.calc_tan.get_descr;


	self.calc_arccos:=tcalc_arccos.create(self.Edit_input_data,
														self.Memo_log);
   self.Button_arccos.Hint:=self.calc_arccos.get_descr;

	self.calc_arcsin:=tcalc_arcsin.create(self.Edit_input_data,
														self.Memo_log);
   self.Button_arcsin.Hint:=self.calc_arcsin.get_descr;

	self.calc_arctan:=tcalc_arctan.create(self.Edit_input_data,
														self.Memo_log);
   self.Button_arctan.Hint:=self.calc_arctan.get_descr;




	self.calc_cosh:=tcalc_cosh.create(self.Edit_input_data,
														self.Memo_log);
   self.Button_cosh.Hint:=self.calc_cosh.get_descr;

	self.calc_sinh:=tcalc_sinh.create(self.Edit_input_data,
														self.Memo_log);
   self.Button_sinh.Hint:=self.calc_sinh.get_descr;

	self.calc_tanh:=tcalc_tanh.create(self.Edit_input_data,
														self.Memo_log);
   self.Button_tanh.Hint:=self.calc_tanh.get_descr;


	self.calc_arccosh:=tcalc_arccosh.create(self.Edit_input_data,
														self.Memo_log);
   self.Button_arccosh.Hint:=self.calc_arccosh.get_descr;

	self.calc_arcsinh:=tcalc_arcsinh.create(self.Edit_input_data,
														self.Memo_log);
   self.Button_arcsinh.Hint:=self.calc_arcsinh.get_descr;

	self.calc_arctanh:=tcalc_arctanh.create(self.Edit_input_data,
														self.Memo_log);
   self.Button_arctanh.Hint:=self.calc_arctanh.get_descr;





	self.calc_cycletorad:=tcalc_cycletorad.create(self.Edit_input_data,
														self.Memo_log);
   self.Button_cycletorad.Hint:=self.calc_cycletorad.get_descr;

	self.calc_radtocycle:=tcalc_radtocycle.create(self.Edit_input_data,
														self.Memo_log);
   self.Button_radtocycle.Hint:=self.calc_radtocycle.get_descr;

	self.calc_radtograd:=tcalc_radtograd.create(self.Edit_input_data,
														self.Memo_log);
   self.Button_radtograd.Hint:=self.calc_radtograd.get_descr;

	self.calc_gradtorad:=tcalc_gradtorad.create(self.Edit_input_data,
														self.Memo_log);
   self.Button_gradtorad.Hint:=self.calc_gradtorad.get_descr;



	self.calc_degtorad:=tcalc_degtorad.create(self.Edit_input_data,
														self.Memo_log);
   self.Button_degtorad.Hint:=self.calc_degtorad.get_descr;

	self.calc_radtodeg:=tcalc_radtodeg.create(self.Edit_input_data,
														self.Memo_log);
   self.Button_radtodeg.Hint:=self.calc_radtodeg.get_descr;

	self.calc_degtograd:=tcalc_degtograd.create(self.Edit_input_data,
														self.Memo_log);
   self.Button_degtograd.Hint:=self.calc_degtograd.get_descr;

	self.calc_gradtodeg:=tcalc_gradtodeg.create(self.Edit_input_data,
														self.Memo_log);
   self.Button_gradtodeg.Hint:=self.calc_gradtodeg.get_descr;

   self.set_calc_func(name_add);

end;

procedure TForm1.SpinEdit_DigitsChange(Sender: TObject);
begin
  self.obj_func_calc.Digits:=self.SpinEdit_Digits.Value;
end;

procedure TForm1.SpinEdit_PrecisionChange(Sender: TObject);
begin
  self.obj_func_calc.Precision:=self.SpinEdit_Precision.Value;
end;



procedure TForm1.Button_addClick(Sender: TObject);
begin
	self.set_calc_func(name_add);
end;

procedure TForm1.Button_tanClick(Sender: TObject);
begin
 self.set_calc_func(name_tan);
end;

procedure TForm1.Button_tanhClick(Sender: TObject);
begin
 self.set_calc_func(name_tanh);
end;

procedure TForm1.ComboBox_log_val_formatChange(Sender: TObject);
begin
		case self.ComboBox_log_val_format.ItemIndex of
			0 : begin
					self.obj_func_calc.format:=ffcurrency;
				end;
			1 : begin
					self.obj_func_calc.format:=ffExponent;
				end;
			2 : begin
					self.obj_func_calc.format:=ffFixed;
				end;
			3 : begin
					self.obj_func_calc.format:=ffGeneral;
				end;
			4 : begin
					self.obj_func_calc.format:=ffnumber;
				end;
		else
			begin
				showmessage('Эта замечательный формат ещё не поддерживается. ');
				exit;
			end;
      end;

end;

procedure TForm1.Edit_input_dataKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key=13 then
  	begin
   	self.obj_func_calc.button_enter;
  	end;
end;



procedure TForm1.Button_subClick(Sender: TObject);
begin
	self.set_calc_func(name_sub);
end;

procedure TForm1.Button_multClick(Sender: TObject);
begin
	self.set_calc_func(name_mult);
end;

procedure TForm1.Button_powerClick(Sender: TObject);
begin
  self.set_calc_func(name_power);
end;

procedure TForm1.Button_radtocycleClick(Sender: TObject);
begin
   self.set_calc_func(name_cycletorad);
	self.obj_func_calc.button_enter;
end;

procedure TForm1.Button_radtodegClick(Sender: TObject);
begin
   self.set_calc_func(name_radtodeg);
	self.obj_func_calc.button_enter;
end;

procedure TForm1.Button_radtogradClick(Sender: TObject);
begin
    self.set_calc_func(name_radtograd);
	self.obj_func_calc.button_enter;
end;

procedure TForm1.Button_sinClick(Sender: TObject);
begin
 self.set_calc_func(name_radtocycle);
	self.obj_func_calc.button_enter;
end;

procedure TForm1.Button_sincosClick(Sender: TObject);
begin
	self.set_calc_func(name_sincos);
	self.obj_func_calc.button_enter;
end;

procedure TForm1.Button_sinhClick(Sender: TObject);
begin
 self.set_calc_func(name_sinh);
	self.obj_func_calc.button_enter;
end;

procedure TForm1.Button_divClick(Sender: TObject);
begin
  self.set_calc_func(name_div);
end;

procedure TForm1.Button_gradtodegClick(Sender: TObject);
begin
      self.set_calc_func(name_gradtodeg);
	self.obj_func_calc.button_enter;
end;

procedure TForm1.Button_gradtoradClick(Sender: TObject);
begin
     self.set_calc_func(name_gradtorad);
	self.obj_func_calc.button_enter;
end;

procedure TForm1.Button_cosClick(Sender: TObject);
begin
 self.set_calc_func(name_cos);
	self.obj_func_calc.button_enter;
end;

procedure TForm1.Button_coshClick(Sender: TObject);
begin
 self.set_calc_func(name_cosh);
	self.obj_func_calc.button_enter;
end;

procedure TForm1.Button_cycletoradClick(Sender: TObject);
begin
  self.set_calc_func(name_cycletorad);
	self.obj_func_calc.button_enter;
end;

procedure TForm1.Button_degtogradClick(Sender: TObject);
begin
     self.set_calc_func(name_degtograd);
	self.obj_func_calc.button_enter;
end;

procedure TForm1.Button_degtoradClick(Sender: TObject);
begin
  self.set_calc_func(name_degtorad);
	self.obj_func_calc.button_enter;
end;

procedure TForm1.Button_arccosClick(Sender: TObject);
begin
 self.set_calc_func(name_arccos);
	self.obj_func_calc.button_enter;
end;

procedure TForm1.Button_arccoshClick(Sender: TObject);
begin
 self.set_calc_func(name_arccosh);
	self.obj_func_calc.button_enter;
end;

procedure TForm1.Button_arcsinClick(Sender: TObject);
begin
 self.set_calc_func(name_arcsin);
	self.obj_func_calc.button_enter;
end;

procedure TForm1.Button_arcsinhClick(Sender: TObject);
begin
 self.set_calc_func(name_arcsinh);
	self.obj_func_calc.button_enter;
end;

procedure TForm1.Button_arctanClick(Sender: TObject);
begin
 self.set_calc_func(name_arctan);
	self.obj_func_calc.button_enter;
end;

procedure TForm1.Button_arctanhClick(Sender: TObject);
begin
 self.set_calc_func(name_arctanh);
	self.obj_func_calc.button_enter;
end;

procedure TForm1.Button_const_piClick(Sender: TObject);
begin
  self.Edit_input_data.Text:=floattostr(pi);
end;

procedure TForm1.Button_log_resetClick(Sender: TObject);
begin
  self.obj_func_calc.button_reset;
  self.obj_func_calc.button_select;
end;




function TForm1.set_calc_func(calc_func_name : tcalc_func_name ) : integer;
begin
		case calc_func_name of
			name_add : begin
				self.obj_func_calc:=self.calc_add;
			end;
			name_sub : begin
				self.obj_func_calc:=self.calc_sub;
			end;
			name_mult : begin
				self.obj_func_calc:=self.calc_mult;
			end;
			name_div : begin
				self.obj_func_calc:=self.calc_div;
			end;
			name_power : begin
				self.obj_func_calc:=self.calc_power;
			end;
			name_sincos : begin
				self.obj_func_calc:=self.calc_sincos;
			end;
			name_cos : begin
				self.obj_func_calc:=self.calc_cos;
			end;
			name_sin : begin
				self.obj_func_calc:=self.calc_sin;
			end;
			name_tan : begin
				self.obj_func_calc:=self.calc_tan;
			end;
			name_arccos : begin
				self.obj_func_calc:=self.calc_arccos;
			end;
			name_arcsin : begin
				self.obj_func_calc:=self.calc_arcsin;
			end;
			name_arctan : begin
				self.obj_func_calc:=self.calc_arctan;
			end;
			name_cosh : begin
				self.obj_func_calc:=self.calc_cosh;
			end;
			name_sinh : begin
				self.obj_func_calc:=self.calc_sinh;
			end;
			name_tanh : begin
				self.obj_func_calc:=self.calc_tanh;
			end;
			name_arccosh : begin
				self.obj_func_calc:=self.calc_arccosh;
			end;
			name_arcsinh : begin
				self.obj_func_calc:=self.calc_arcsinh;
			end;
			name_arctanh : begin
				self.obj_func_calc:=self.calc_arctanh;
			end;



			name_cycletorad : begin
				self.obj_func_calc:=self.calc_cycletorad;
			end;
			name_radtocycle : begin
				self.obj_func_calc:=self.calc_radtocycle;
			end;
			name_radtograd : begin
				self.obj_func_calc:=self.calc_radtograd;
			end;
			name_gradtorad : begin
				self.obj_func_calc:=self.calc_gradtorad;
			end;


			name_degtorad : begin
				self.obj_func_calc:=self.calc_degtorad;
			end;
			name_radtodeg : begin
				self.obj_func_calc:=self.calc_radtodeg;
			end;
			name_degtograd : begin
				self.obj_func_calc:=self.calc_degtograd;
			end;
			name_gradtodeg : begin
				self.obj_func_calc:=self.calc_gradtodeg;
			end;

		else
			begin
				showmessage('Эта замечательная функция ещё не поддерживается. ');
				exit;
			end;
      end;

//		self.Button_log_reset.OnClick:=@self.obj_func_calc.button_reset;
      self.obj_func_calc.get_descr;
		self.obj_func_calc.button_select;
end;

initialization
  {$I unit_main.lrs}

end.

